"use strict"

exports.addHook = function (list, callback) {
    if (list != null) {
        list.push(callback)
        return list
    } else {
        return [callback]
    }
}

exports.removeHook = function (list, callback) {
    if (list == null) return undefined
    if (list.length === 1) {
        if (list[0] === callback) return undefined
    } else {
        var index = list.indexOf(callback)

        if (index >= 0) list.splice(index, 1)
    }
    return list
}

exports.hasHook = function (list, callback) {
    if (list == null) return false
    if (list.length > 1) return list.indexOf(callback) >= 0
    return list[0] === callback
}

// TODO: cache and remove these traversals for 0.4.
// Note that a timeout of 0 means to inherit the parent.
exports.getTimeout = function (test) {
    while (!test.timeout && test.parent != null) {
        test = test.parent
    }

    return test.timeout || 2000 // ms - default timeout
}

// Note that a slowness threshold of 0 means to inherit the parent.
exports.getSlow = function (test) {
    while (!test.slow && test.parent != null) {
        test = test.parent
    }

    return test.slow || 75 // ms - default slow threshold
}
